/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Fast.xs. Do not edit this file, edit Fast.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/Redis/Cluster/Fast.xs"
#ifdef __cplusplus
extern "C" {
#endif

#define PERL_NO_GET_CONTEXT /* we want efficiency */
#include <EXTERN.h>
#include <perl.h>
#include <XSUB.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include "hiredis_cluster/adapters/libevent.h"
#include "hiredis_cluster/hircluster.h"

#ifdef __cplusplus
} /* extern "C" */
#endif

#define NEED_newRV_noinc
#define NEED_my_strlcpy
#include "ppport.h"

#define ONE_SECOND_TO_MICRO 1000000

#define DEBUG_MSG(fmt, ...) \
    if (self->debug) {                                                  \
        fprintf(stderr, "[%d][%d][%s:%d:%s]: ", getpid(), getppid(), __FILE__, __LINE__, __func__);  \
        fprintf(stderr, fmt, __VA_ARGS__);                              \
        fprintf(stderr, "\n");                                          \
    }

#define DEBUG_EVENT_BASE() \
    if (self->debug) {                                                  \
        event_base_dump_events(self->cluster_event_base, stderr);       \
    }

typedef struct redis_cluster_fast_reply_s {
    SV *result;
    SV *error;
} redis_cluster_fast_reply_t;

typedef struct cmd_reply_context_s {
    void *self;
    SV *result;
    SV *error;
    int done;
} cmd_reply_context_t;

typedef struct redis_cluster_fast_s {
    redisClusterAsyncContext *acc;
    struct event_base *cluster_event_base;
    char *hostnames;
    int debug;
    int max_retry;
    struct timeval connect_timeout;
    struct timeval command_timeout;
    pid_t pid;
} redis_cluster_fast_t, *Redis__Cluster__Fast;

static redis_cluster_fast_reply_t
Redis__Cluster__Fast_decode_reply(pTHX_ Redis__Cluster__Fast self, redisReply *reply) {
    redis_cluster_fast_reply_t res = {NULL, NULL};

    switch (reply->type) {
        case REDIS_REPLY_ERROR:
            res.error = newSVpvn(reply->str, reply->len);
            break;

        case REDIS_REPLY_BIGNUM:
        case REDIS_REPLY_DOUBLE:
        case REDIS_REPLY_STATUS:
        case REDIS_REPLY_STRING:
        case REDIS_REPLY_VERB:
            res.result = newSVpvn(reply->str, reply->len);
            break;

        case REDIS_REPLY_INTEGER:
        case REDIS_REPLY_BOOL:
            res.result = newSViv(reply->integer);
            break;
        case REDIS_REPLY_NIL:
            res.result = &PL_sv_undef;
            break;

        case REDIS_REPLY_MAP:
        case REDIS_REPLY_SET:
        case REDIS_REPLY_ATTR: {
            size_t i;
            char *key;
            HV *hv = newHV();

            res.result = newRV_noinc((SV *) hv);

            for (i = 0; i < reply->elements; i++) {
                if (i % 2 == 0) {
                    key = reply->element[i]->str;
                } else {
                    redis_cluster_fast_reply_t elem = {NULL, NULL};
                    elem = Redis__Cluster__Fast_decode_reply(aTHX_ self, reply->element[i]);
                    if (elem.result) {
                        hv_store(hv, key, strlen(key), SvREFCNT_inc(elem.result), 0);
                    } else {
                        hv_store(hv, key, strlen(key), newSV(0), 0);
                    }
                    if (elem.error && !res.error) {
                        res.error = elem.error;
                    }
                }
            }
            break;
        }

        case REDIS_REPLY_PUSH:
        case REDIS_REPLY_ARRAY: {
            AV *av = newAV();
            size_t i;
            res.result = newRV_noinc((SV *) av);

            for (i = 0; i < reply->elements; i++) {
                redis_cluster_fast_reply_t elem = {NULL, NULL};
                elem = Redis__Cluster__Fast_decode_reply(aTHX_ self, reply->element[i]);
                if (elem.result) {
                    av_push(av, elem.result);
                } else {
                    av_push(av, newSV(0));
                }
                if (elem.error && !res.error) {
                    res.error = elem.error;
                }
            }
            break;
        }
    }

    return res;
}

void replyCallback(redisClusterAsyncContext *cc, void *r, void *privdata) {
    dTHX;

    cmd_reply_context_t *reply_t;
    Redis__Cluster__Fast self;
    redisReply *reply;

    reply_t = (cmd_reply_context_t *) privdata;
    self = (Redis__Cluster__Fast) reply_t->self;
    DEBUG_MSG("replycb %s", "start");

    reply = (redisReply *) r;
    if (reply) {
        redis_cluster_fast_reply_t res;
        res = Redis__Cluster__Fast_decode_reply(aTHX_ self, reply);
        reply_t->result = res.result;
        reply_t->error = res.error;
    } else {
        DEBUG_MSG("error: err=%d errstr=%s", cc->err, cc->errstr);
        reply_t->error = newSVpvf("%s", cc->errstr);
    }

    reply_t->done = 1;
}

SV *Redis__Cluster__Fast_connect(pTHX_ Redis__Cluster__Fast self) {
    DEBUG_MSG("%s", "start connect");

    self->pid = getpid();

    self->acc = redisClusterAsyncContextInit();
    if (redisClusterSetOptionAddNodes(self->acc->cc, self->hostnames) != REDIS_OK) {
        return newSVpvf("failed to add nodes: %s", self->acc->cc->errstr);
    }
    if (redisClusterSetOptionConnectTimeout(self->acc->cc, self->connect_timeout) != REDIS_OK) {
        return newSVpvf("failed to set connect timeout: %s", self->acc->cc->errstr);
    }
    if (redisClusterSetOptionTimeout(self->acc->cc, self->command_timeout) != REDIS_OK) {
        return newSVpvf("failed to set command timeout: %s", self->acc->cc->errstr);
    }
    if (redisClusterSetOptionMaxRetry(self->acc->cc, self->max_retry) != REDIS_OK) {
        return newSVpvf("%s", "failed to set max retry");
    }

    if (redisClusterConnect2(self->acc->cc) != REDIS_OK) {
        return newSVpvf("failed to connect: %s", self->acc->cc->errstr);
    }

    self->cluster_event_base = event_base_new();
    if (redisClusterLibeventAttach(self->acc, self->cluster_event_base) != REDIS_OK) {
        return newSVpvf("%s", "failed to attach event base");
    }

    DEBUG_MSG("%s", "done connect");
    return &PL_sv_undef;
}

cluster_node *get_node_by_random(pTHX_ Redis__Cluster__Fast self) {
    cluster_node *selected;
    cluster_node *candidate;
    int node_count;
    nodeIterator ni;

    initNodeIterator(&ni, self->acc->cc);

    /* Select a random node by reservoir sampling. */
    node_count = 1;
    if ((selected = nodeNext(&ni)) == NULL)
        return NULL;
    while ((candidate = nodeNext(&ni)) != NULL) {
        node_count++;
        if ((int) (Drand01() * node_count) == 0)
            selected = candidate;
    }
    return selected;
}

void Redis__Cluster__Fast_run_cmd(pTHX_ Redis__Cluster__Fast self, int argc, const char **argv, size_t *argvlen,
                                  cmd_reply_context_t *reply_t) {
    int status, event_loop_error;
    pid_t current_pid;

    DEBUG_MSG("start: %s", *argv);

    reply_t->done = 0;
    reply_t->self = (void *) self;
    reply_t->result = NULL;
    reply_t->error = NULL;

    current_pid = getpid();
    if (self->pid != current_pid) {
        DEBUG_MSG("%s", "pid changed");
        if (event_reinit(self->cluster_event_base) != 0) {
            reply_t->error = newSVpvf("%s", "event reinit failed");
            return;
        }
        redisClusterAsyncDisconnect(self->acc);
        self->pid = current_pid;
    }

    status = redisClusterAsyncCommandArgv(self->acc, replyCallback, reply_t, argc, argv, argvlen);
    if (status != REDIS_OK) {
        if (self->acc->err == REDIS_ERR_OTHER &&
            strcmp(self->acc->errstr, "No keys in command(must have keys for redis cluster mode)") == 0) {
            cluster_node *node;

            DEBUG_MSG("not cluster command, fallback to CommandToNode: err=%d errstr=%s",
                      self->acc->err,
                      self->acc->errstr);

            node = get_node_by_random(aTHX_ self);
            if (node == NULL) {
                reply_t->error = newSVpvf("%s", "No node found");
                return;
            }

            status = redisClusterAsyncCommandArgvToNode(self->acc, node, replyCallback, reply_t, argc, argv, argvlen);
            if (status != REDIS_OK) {
                DEBUG_MSG("error: err=%d errstr=%s", self->acc->err, self->acc->errstr);
                reply_t->error = newSVpvf("%s", self->acc->errstr);
                return;
            }
        } else {
            DEBUG_MSG("error: err=%d errstr=%s", self->acc->err, self->acc->errstr);
            reply_t->error = newSVpvf("%s", self->acc->errstr);
            return;
        }
    }

    while (!reply_t->done) {
        DEBUG_EVENT_BASE();
        event_loop_error = event_base_loop(self->cluster_event_base, EVLOOP_ONCE);
        if (event_loop_error != 0) {
            reply_t->error = newSVpvf("%s %d", "event_base_loop failed", event_loop_error);
            break;
        }
    }
}

#line 288 "lib/Redis/Cluster/Fast.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 432 "lib/Redis/Cluster/Fast.c"

XS_EUPXS(XS_Redis__Cluster__Fast__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Cluster__Fast__new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cls");
    {
#line 285 "lib/Redis/Cluster/Fast.xs"
    redis_cluster_fast_t* self;
#line 443 "lib/Redis/Cluster/Fast.c"
	Redis__Cluster__Fast	RETVAL;
	char*	cls = (char *)SvPV_nolen(ST(0))
;
#line 287 "lib/Redis/Cluster/Fast.xs"
    Newxz(self, sizeof(redis_cluster_fast_t), redis_cluster_fast_t);
    RETVAL = self;
#line 450 "lib/Redis/Cluster/Fast.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Redis::Cluster::Fast", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Redis__Cluster__Fast___set_debug); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Cluster__Fast___set_debug)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, val");
    {
	int	RETVAL;
	dXSTARG;
	Redis__Cluster__Fast	self;
	int	val = (int)SvIV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Cluster::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Cluster__Fast,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Redis::Cluster::Fast::__set_debug",
			"self", "Redis::Cluster::Fast",
			refstr, ST(0)
		);
	}
;
#line 295 "lib/Redis/Cluster/Fast.xs"
    DEBUG_MSG("%s", "DEBUG true");
    RETVAL = self->debug = val;
#line 491 "lib/Redis/Cluster/Fast.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Redis__Cluster__Fast___set_servers); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Cluster__Fast___set_servers)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, hostnames");
    {
	Redis__Cluster__Fast	self;
	char*	hostnames = (char *)SvPV_nolen(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Cluster::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Cluster__Fast,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Redis::Cluster::Fast::__set_servers",
			"self", "Redis::Cluster::Fast",
			refstr, ST(0)
		);
	}
;
#line 303 "lib/Redis/Cluster/Fast.xs"
    if (self->hostnames) {
        Safefree(self->hostnames);
        self->hostnames = NULL;
    }

    if (hostnames) {
        Newx(self->hostnames, strlen(hostnames) + 1, char);
        my_strlcpy(self->hostnames, hostnames, strlen(hostnames) + 1);
        DEBUG_MSG("%s %s", "set hostnames", self->hostnames);
    }
#line 534 "lib/Redis/Cluster/Fast.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Redis__Cluster__Fast___set_connect_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Cluster__Fast___set_connect_timeout)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, double_sec");
    {
#line 317 "lib/Redis/Cluster/Fast.xs"
    int second, micro_second;
    struct timeval timeout;
#line 550 "lib/Redis/Cluster/Fast.c"
	Redis__Cluster__Fast	self;
	double	double_sec = (double)SvNV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Cluster::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Cluster__Fast,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Redis::Cluster::Fast::__set_connect_timeout",
			"self", "Redis::Cluster::Fast",
			refstr, ST(0)
		);
	}
;
#line 320 "lib/Redis/Cluster/Fast.xs"
    second = (int) (double_sec);
    micro_second = (int) (fmod(double_sec * ONE_SECOND_TO_MICRO, ONE_SECOND_TO_MICRO) + 0.999);
    timeout.tv_sec = second;
    timeout.tv_usec = micro_second;
    self->connect_timeout = timeout;
    DEBUG_MSG("connect timeout %d, %d", second, micro_second);
#line 575 "lib/Redis/Cluster/Fast.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Redis__Cluster__Fast___set_command_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Cluster__Fast___set_command_timeout)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, double_sec");
    {
#line 330 "lib/Redis/Cluster/Fast.xs"
    int second, micro_second;
    struct timeval timeout;
#line 591 "lib/Redis/Cluster/Fast.c"
	Redis__Cluster__Fast	self;
	double	double_sec = (double)SvNV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Cluster::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Cluster__Fast,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Redis::Cluster::Fast::__set_command_timeout",
			"self", "Redis::Cluster::Fast",
			refstr, ST(0)
		);
	}
;
#line 333 "lib/Redis/Cluster/Fast.xs"
    second = (int) (double_sec);
    micro_second = (int) (fmod(double_sec * ONE_SECOND_TO_MICRO, ONE_SECOND_TO_MICRO) + 0.999);
    timeout.tv_sec = second;
    timeout.tv_usec = micro_second;
    self->command_timeout = timeout;
    DEBUG_MSG("command timeout %d, %d", second, micro_second);
#line 616 "lib/Redis/Cluster/Fast.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Redis__Cluster__Fast___set_max_retry); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Cluster__Fast___set_max_retry)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, max_retry");
    {
	Redis__Cluster__Fast	self;
	int	max_retry = (int)SvIV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Cluster::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Cluster__Fast,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Redis::Cluster::Fast::__set_max_retry",
			"self", "Redis::Cluster::Fast",
			refstr, ST(0)
		);
	}
;
#line 343 "lib/Redis/Cluster/Fast.xs"
    self->max_retry = max_retry;
    DEBUG_MSG("max_retry %d", max_retry);
#line 649 "lib/Redis/Cluster/Fast.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Redis__Cluster__Fast___connect); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Cluster__Fast___connect)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Redis__Cluster__Fast	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Cluster::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Cluster__Fast,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Redis::Cluster::Fast::__connect",
			"self", "Redis::Cluster::Fast",
			refstr, ST(0)
		);
	}
;
#line 349 "lib/Redis/Cluster/Fast.xs"
    RETVAL = Redis__Cluster__Fast_connect(aTHX_ self);
#line 680 "lib/Redis/Cluster/Fast.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Redis__Cluster__Fast___std_cmd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Cluster__Fast___std_cmd)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 356 "lib/Redis/Cluster/Fast.xs"
    cmd_reply_context_t* result_context;
    char** argv;
    size_t* argvlen;
    STRLEN len;
    int argc, i;
#line 703 "lib/Redis/Cluster/Fast.c"
	Redis__Cluster__Fast	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Cluster::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Cluster__Fast,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Redis::Cluster::Fast::__std_cmd",
			"self", "Redis::Cluster::Fast",
			refstr, ST(0)
		);
	}
;
#line 362 "lib/Redis/Cluster/Fast.xs"
    if (!self->acc) {
       croak("Not connected to any server");
    }

    argc = items - 1;
    Newx(argv, sizeof(char*) * argc, char*);
    Newx(argvlen, sizeof(size_t) * argc, size_t);
    Newx(result_context, sizeof(cmd_reply_context_t), cmd_reply_context_t);

    for (i = 0; i < argc; i++) {
        argv[i] = SvPV(ST(i + 1), len);
        argvlen[i] = len;
    }

    Redis__Cluster__Fast_run_cmd(aTHX_ self, argc, (const char **) argv, argvlen, result_context);

    ST(0) = result_context->result ?
            sv_2mortal(result_context->result) : &PL_sv_undef;
    ST(1) = result_context->error ?
            sv_2mortal(result_context->error) : &PL_sv_undef;

    Safefree(argv);
    Safefree(argvlen);
    Safefree(result_context);

    XSRETURN(2);
#line 746 "lib/Redis/Cluster/Fast.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Redis__Cluster__Fast_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Cluster__Fast_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Redis__Cluster__Fast	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Cluster__Fast,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Redis::Cluster::Fast::DESTROY",
			"self")
;
#line 392 "lib/Redis/Cluster/Fast.xs"
    if (self->cluster_event_base) {
        DEBUG_MSG("%s", "trying to free event_base");
        if ((self->pid == getpid()) || (event_reinit(self->cluster_event_base) == 0)){
            redisClusterAsyncDisconnect(self->acc);
            event_base_dispatch(self->cluster_event_base);
            event_base_free(self->cluster_event_base);
            self->cluster_event_base = NULL;
        } else {
           warn("event_reinit failed. Skip disconnecting and freeing event_base on destruction");
        }
    }

    redisClusterAsyncFree(self->acc);
    self->acc = NULL;

    if (self->hostnames) {
        DEBUG_MSG("%s", "free hostnames");
        Safefree(self->hostnames);
        self->hostnames = NULL;
    }

    DEBUG_MSG("%s", "done");
    Safefree(self);
#line 795 "lib/Redis/Cluster/Fast.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Redis__Cluster__Fast); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Redis__Cluster__Fast)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Redis::Cluster::Fast::_new", XS_Redis__Cluster__Fast__new);
        newXS_deffile("Redis::Cluster::Fast::__set_debug", XS_Redis__Cluster__Fast___set_debug);
        newXS_deffile("Redis::Cluster::Fast::__set_servers", XS_Redis__Cluster__Fast___set_servers);
        newXS_deffile("Redis::Cluster::Fast::__set_connect_timeout", XS_Redis__Cluster__Fast___set_connect_timeout);
        newXS_deffile("Redis::Cluster::Fast::__set_command_timeout", XS_Redis__Cluster__Fast___set_command_timeout);
        newXS_deffile("Redis::Cluster::Fast::__set_max_retry", XS_Redis__Cluster__Fast___set_max_retry);
        newXS_deffile("Redis::Cluster::Fast::__connect", XS_Redis__Cluster__Fast___connect);
        newXS_deffile("Redis::Cluster::Fast::__std_cmd", XS_Redis__Cluster__Fast___std_cmd);
        newXS_deffile("Redis::Cluster::Fast::DESTROY", XS_Redis__Cluster__Fast_DESTROY);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
